﻿using Microsoft.Win32;
using System;
using System.Windows.Forms;

namespace VPNClient
{
    public partial class TabOption : RoundTab
    {
        public TabOption()
        {
            InitializeComponent();
        }

        /****************************************
        * Purpose: Set the client visibility in the cloud
        * Input: Default UI callback function parameters
        * Output: N/A
        * Return: N/A
        * Author: Jemin Su
        * Date: 2017-02-16
        ****************************************/
        private void ckVisible_CheckedChanged(object sender, EventArgs e)
        {
            ConfigLoader loader = ConfigLoader.GetInstance();
            ClientConfig config = loader.GetConfig();
            config.client_to_client = this.ckbStartService.Checked;
            loader.SaveConfig(config);

            if (this.ckVisible.Checked)
            {
                MainForm.GetInstance().SetClientVisible(true);
            }
            else
            {
                MainForm.GetInstance().SetClientVisible(false);
            }
        }

        /****************************************
        * Purpose: Set the client start mode in the cloud
        * Input: Default UI callback function parameters
        * Output: N/A
        * Return: N/A
        * Author: Jemin Su
        * Date: 2017-04-06
        ****************************************/
        private void ckbStartService_CheckedChanged(object sender, EventArgs e)
        {
            ConfigLoader loader = ConfigLoader.GetInstance();
            ClientConfig config = loader.GetConfig();
            config.start_as_service = this.ckbStartService.Checked;
            loader.SaveConfig(config);

            /* Set the program to start up run */
            RegistryKey rk = Registry.CurrentUser.OpenSubKey("SOFTWARE\\Microsoft\\Windows\\CurrentVersion\\Run", true);
            String appName = "MRC_Client";
            if (this.ckbStartService.Checked)
            {
                rk.SetValue(appName, Application.ExecutablePath.ToString());
                MainForm.GetInstance().SetServiceMode(true);
            }
            else
            {
                rk.DeleteValue(appName, false);
                MainForm.GetInstance().SetServiceMode(false);
            }
        }
    }
}
